/*
 * Handle Accumulating VST events
 *
 */

autowatch = 1;
inlets = 1;
outlets = 4;

var my_events = [];

function setText() {
	evs=[];
	evf="";
/*	for( i=0; i<my_events.length; i++ ) {
		evs.push(my_events[i].join(" "));
	}
	outlet(2,["set", evs.join(",")]);*/
	
	for( i=0; i<my_events.length; i++ ) {
		evs = evs.concat(my_events[i]);
		evf = "%s $f";
	}
	outlet(3, ["format", evf]);
	outlet(2, ["set"].concat(evs));
}

function loadbang() {
	// Bang the output so we get the text
	outlet(0, "bang");
}

function append(/*list*/) {
	argarr = Array.prototype.slice.call(arguments);
	my_events.push(argarr);
	setText();
}

function merge(/*list*/) {
	argarr = Array.prototype.slice.call(arguments);
	
	// Find any matching events and update them
	for( i=0; i<my_events.length; i++ ) {
		if( my_events[i][0] == argarr[0] ) {
			my_events[i] = argarr;
			break;
		}
	}
	
	// If we didn't get a match, append it
	if( i == my_events.length ) {
		my_events.push( argarr );
	}

	// Push the updated data back to the text box
	setText();
}


function send(t) {
	for( i=0; i<my_events.length; i++ ) {
		outlet( 1, my_events[i] );
	}
}

function text(t) {
	/*argarr = Array.prototype.slice.call(arguments);

	for( i=0; i<argarr.length; i++ ) {
		outlet(1, argarr[i].constructor.toString());
	}*/
	
	evs = t.match(/"(?:\\"|[^"])+"|,|[^, \t\r\n]+/g) || [];
	my_events = [];
	accum = [];
	for( i=0; i<evs.length; i++ ) {
		if( evs[i] == "," ) {
			my_events.push( accum );
			accum = [];
		} else if( evs[i].charAt(0) == "\"" ) {
			accum.push( evs[i].substr(1, evs[i].length-2 ) );
		} else {
			accum.push( evs[i] );
		}
	}
}
